<template>
  <div class="app-container">
    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="45%" v-dialogDrag append-to-body>
      <el-form ref="formRef" :model="formData" :rules="formRules" v-loading="formLoading" label-width="100px">
                    <el-form-item label="资料名称" prop="materialName">
                      <el-input v-model="formData.materialName" placeholder="请输入资料名称" />
                    </el-form-item>
                    <el-form-item label="下载用户" prop="userName">
                      <el-input v-model="formData.userName" placeholder="请输入下载用户" />
                    </el-form-item>
                    <el-form-item label="下载时间" prop="downloadTime">
                      <el-date-picker clearable v-model="formData.downloadTime" type="date" value-format="timestamp" placeholder="选择下载时间" />
                    </el-form-item>
<!--                    <el-form-item label="IP地址" prop="ipAddress">
                      <el-input v-model="formData.ipAddress" placeholder="请输入IP地址" />
                    </el-form-item>-->
      </el-form>
              <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="formLoading">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
  import * as MaterialDownloadLogApi from '@/api/server/materialdownloadlog';
      export default {
    name: "MaterialDownloadLogForm",
    components: {
                    },
    data() {
      return {
        // 弹出层标题
        dialogTitle: "",
        // 是否显示弹出层
        dialogVisible: false,
        // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
        formLoading: false,
        // 表单参数
        formData: {
                            id: undefined,
                            materialId: undefined,
                            userId: undefined,
                            downloadTime: undefined,
                            ipAddress: undefined,
                            materialName: undefined,
                            userName: undefined,
        },
        // 表单校验
        formRules: {
                        materialId: [{ required: true, message: '资料ID不能为空', trigger: 'blur' }],
                        userId: [{ required: true, message: '用户ID不能为空', trigger: 'blur' }],
                        downloadTime: [{ required: true, message: '下载时间不能为空', trigger: 'blur' }],
        },
                        };
    },
    methods: {
      /** 打开弹窗 */
     async open(id) {
        this.dialogVisible = true;
        this.reset();
        // 修改时，设置数据
        if (id) {
          this.formLoading = true;
          try {
            const res = await MaterialDownloadLogApi.getMaterialDownloadLog(id);
            this.formData = res.data;
            this.title = "修改资料下载日志";
          } finally {
            this.formLoading = false;
          }
        }
        this.title = "新增资料下载日志";
              },
      /** 提交按钮 */
      async submitForm() {
        // 校验主表
        await this.$refs["formRef"].validate();
                  this.formLoading = true;
        try {
          const data = this.formData;
                  // 修改的提交
          if (data.id) {
            await MaterialDownloadLogApi.updateMaterialDownloadLog(data);
            this.$modal.msgSuccess("修改成功");
            this.dialogVisible = false;
            this.$emit('success');
            return;
          }
          // 添加的提交
          await MaterialDownloadLogApi.createMaterialDownloadLog(data);
          this.$modal.msgSuccess("新增成功");
          this.dialogVisible = false;
          this.$emit('success');
        } finally {
          this.formLoading = false;
        }
      },
                      /** 表单重置 */
      reset() {
        this.formData = {
                            id: undefined,
                            materialId: undefined,
                            userId: undefined,
                            downloadTime: undefined,
                            ipAddress: undefined,
                            materialName: undefined,
                            userName: undefined,
        };
        this.resetForm("formRef");
      }
    }
  };
</script>
